Index: /palm/trunk/SOURCE/data_output_module.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_module.f90	(revision 4140)
+++ /palm/trunk/SOURCE/data_output_module.f90	(revision 4141)
@@ -1559,18 +1338,1156 @@
       append_internal = .FALSE.
 
-      attribute%name         = TRIM( name )
+      attribute%name         = TRIM( attribute_name )
       attribute%data_type    = 'real64'
       attribute%value_real64 = value
 
-      IF ( PRESENT( variable ) )  THEN
-         return_value = dom_def_att_save( TRIM( filename ), TRIM( variable ), &
-                                                attribute=attribute, append=append_internal )
+      return_value = save_attribute_in_database( file_name=TRIM( file_name ), &
+                        variable_name=TRIM( variable_name_internal ),         &
+                        attribute=attribute, append=append_internal )
+   ENDIF
+
+END FUNCTION dom_def_att_real64
+
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> End output definition.
+!> The database is cleared from unused files and dimensions. Then, the output files are initialized
+!> and prepared for writing output values to them. The saved values of the dimensions are written
+!> to the files.
+!--------------------------------------------------------------------------------------------------!
+FUNCTION dom_def_end() RESULT( return_value )
+
+   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_end'  !< name of routine
+
+   INTEGER ::  d             !< loop index
+   INTEGER ::  f             !< loop index
+   INTEGER ::  return_value  !< return value
+
+   INTEGER(KIND=1), DIMENSION(:), ALLOCATABLE, TARGET ::  values_int8           !< target array for dimension values
+   INTEGER(KIND=2), DIMENSION(:), ALLOCATABLE, TARGET ::  values_int16          !< target array for dimension values
+   INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE, TARGET ::  values_int32          !< target array for dimension values
+   INTEGER(iwp),    DIMENSION(:), ALLOCATABLE, TARGET ::  values_intwp          !< target array for dimension values
+   
+   INTEGER(KIND=1), DIMENSION(:), POINTER, CONTIGUOUS ::  values_int8_pointer   !< pointer to target array
+   INTEGER(KIND=2), DIMENSION(:), POINTER, CONTIGUOUS ::  values_int16_pointer  !< pointer to target array
+   INTEGER(KIND=4), DIMENSION(:), POINTER, CONTIGUOUS ::  values_int32_pointer  !< pointer to target array
+   INTEGER(iwp),    DIMENSION(:), POINTER, CONTIGUOUS ::  values_intwp_pointer  !< pointer to target array
+
+   REAL(KIND=4), DIMENSION(:), ALLOCATABLE, TARGET ::  values_real32            !< target array for dimension values
+   REAL(KIND=8), DIMENSION(:), ALLOCATABLE, TARGET ::  values_real64            !< target array for dimension values
+   REAL(wp),     DIMENSION(:), ALLOCATABLE, TARGET ::  values_realwp            !< target array for dimension values
+
+   REAL(KIND=4), DIMENSION(:), POINTER, CONTIGUOUS ::  values_real32_pointer    !< pointer to target array
+   REAL(KIND=8), DIMENSION(:), POINTER, CONTIGUOUS ::  values_real64_pointer    !< pointer to target array
+   REAL(wp),     DIMENSION(:), POINTER, CONTIGUOUS ::  values_realwp_pointer    !< pointer to target array
+
+
+   return_value = 0
+   CALL internal_message( 'debug', routine_name // ': start' )
+
+   !-- Clear database from empty files and unused dimensions
+   IF ( nfiles > 0 )  return_value = cleanup_database()
+
+   IF ( return_value == 0 )  THEN
+      DO  f = 1, nfiles
+
+         !-- Skip initialization if file is already initialized
+         IF ( files(f)%is_init )  CYCLE
+
+         CALL internal_message( 'debug', routine_name // ': initialize file "' // &
+                                TRIM( files(f)%name ) // '"' )
+
+         !-- Open file
+         CALL open_output_file( files(f)%format, files(f)%name, files(f)%id, &
+                                return_value=return_value )
+
+         !-- Initialize file header:
+         !-- define dimensions and variables and write attributes
+         IF ( return_value == 0 )  &
+            CALL init_file_header( files(f), return_value=return_value )
+
+         !-- End file definition
+         IF ( return_value == 0 )  &
+            CALL stop_file_header_definition( files(f)%format, files(f)%id, &
+                                              files(f)%name, return_value )
+
+         IF ( return_value == 0 )  THEN
+
+            !-- Flag file as initialized
+            files(f)%is_init = .TRUE.
+
+            !-- Write dimension values into file
+            DO  d = 1, SIZE( files(f)%dimensions )
+               IF ( ALLOCATED( files(f)%dimensions(d)%values_int8 ) )  THEN
+                  ALLOCATE( values_int8(files(f)%dimensions(d)%bounds(1): &
+                                        files(f)%dimensions(d)%bounds(2)) )
+                  values_int8 = files(f)%dimensions(d)%values_int8
+                  values_int8_pointer => values_int8
+                  return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
+                                    bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
+                                    bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
+                                    values_int8_1d=values_int8_pointer )
+                  DEALLOCATE( values_int8 )
+               ELSEIF ( ALLOCATED( files(f)%dimensions(d)%values_int16 ) )  THEN
+                  ALLOCATE( values_int16(files(f)%dimensions(d)%bounds(1): &
+                                         files(f)%dimensions(d)%bounds(2)) )
+                  values_int16 = files(f)%dimensions(d)%values_int16
+                  values_int16_pointer => values_int16
+                  return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
+                                    bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
+                                    bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
+                                    values_int16_1d=values_int16_pointer )
+                  DEALLOCATE( values_int16 )
+               ELSEIF ( ALLOCATED( files(f)%dimensions(d)%values_int32 ) )  THEN
+                  ALLOCATE( values_int32(files(f)%dimensions(d)%bounds(1): &
+                                         files(f)%dimensions(d)%bounds(2)) )
+                  values_int32 = files(f)%dimensions(d)%values_int32
+                  values_int32_pointer => values_int32
+                  return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
+                                    bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
+                                    bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
+                                    values_int32_1d=values_int32_pointer )
+                  DEALLOCATE( values_int32 )
+               ELSEIF ( ALLOCATED( files(f)%dimensions(d)%values_intwp ) )  THEN
+                  ALLOCATE( values_intwp(files(f)%dimensions(d)%bounds(1): &
+                                         files(f)%dimensions(d)%bounds(2)) )
+                  values_intwp = files(f)%dimensions(d)%values_intwp
+                  values_intwp_pointer => values_intwp
+                  return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
+                                    bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
+                                    bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
+                                    values_intwp_1d=values_intwp_pointer )
+                  DEALLOCATE( values_intwp )
+               ELSEIF ( ALLOCATED( files(f)%dimensions(d)%values_real32 ) )  THEN
+                  ALLOCATE( values_real32(files(f)%dimensions(d)%bounds(1): &
+                                          files(f)%dimensions(d)%bounds(2)) )
+                  values_real32 = files(f)%dimensions(d)%values_real32
+                  values_real32_pointer => values_real32
+                  return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
+                                    bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
+                                    bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
+                                    values_real32_1d=values_real32_pointer )
+                  DEALLOCATE( values_real32 )
+               ELSEIF ( ALLOCATED( files(f)%dimensions(d)%values_real64 ) )  THEN
+                  ALLOCATE( values_real64(files(f)%dimensions(d)%bounds(1): &
+                                          files(f)%dimensions(d)%bounds(2)) )
+                  values_real64 = files(f)%dimensions(d)%values_real64
+                  values_real64_pointer => values_real64
+                  return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
+                                    bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
+                                    bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
+                                    values_real64_1d=values_real64_pointer )
+                  DEALLOCATE( values_real64 )
+               ELSEIF ( ALLOCATED( files(f)%dimensions(d)%values_realwp ) )  THEN
+                  ALLOCATE( values_realwp(files(f)%dimensions(d)%bounds(1): &
+                                          files(f)%dimensions(d)%bounds(2)) )
+                  values_realwp = files(f)%dimensions(d)%values_realwp
+                  values_realwp_pointer => values_realwp
+                  return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
+                                    bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
+                                    bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
+                                    values_realwp_1d=values_realwp_pointer )
+                  DEALLOCATE( values_realwp )
+               ENDIF
+               IF ( return_value /= 0 )  EXIT
+            ENDDO
+
+         ENDIF
+
+         IF ( return_value /= 0 )  EXIT
+
+      ENDDO
+   ENDIF
+
+   CALL internal_message( 'debug', routine_name // ': finished' )
+
+END FUNCTION dom_def_end
+
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Write variable to file.
+!> Example call:
+!>   dom_write_var( file_name = 'my_output_file_name', &
+!>                  name = 'u', &
+!>                  bounds_start = (/nxl, nys, nzb, time_step/), &
+!>                  bounds_end = (/nxr, nyn, nzt, time_step/), &
+!>                  values_real64_3d = u )
+!> @note The order of dimension bounds must match to the order of dimensions given in call
+!>       'dom_def_var'. I.e., the corresponding variable definition should be like:
+!>          dom_def_var( file_name =  'my_output_file_name', &
+!>                       name = 'u', &
+!>                       dimension_names = (/'x   ', 'y   ', 'z   ', 'time'/), &
+!>                       output_type = <desired-output-type> )
+!> @note The values given do not need to be of the same data type as was defined in the
+!>       corresponding 'dom_def_var' call. If the output format 'netcdf' was chosen, the values are
+!>       automatically converted to the data type given during the definition. If 'binary' was
+!>       chosen, the values are written to file as given in the 'dom_write_var' call.
+!--------------------------------------------------------------------------------------------------!
+FUNCTION dom_write_var( file_name, variable_name, bounds_start, bounds_end,         &
+            values_int8_0d,   values_int8_1d,   values_int8_2d,   values_int8_3d,   &
+            values_int16_0d,  values_int16_1d,  values_int16_2d,  values_int16_3d,  &
+            values_int32_0d,  values_int32_1d,  values_int32_2d,  values_int32_3d,  &
+            values_intwp_0d,  values_intwp_1d,  values_intwp_2d,  values_intwp_3d,  &
+            values_real32_0d, values_real32_1d, values_real32_2d, values_real32_3d, &
+            values_real64_0d, values_real64_1d, values_real64_2d, values_real64_3d, &
+            values_realwp_0d, values_realwp_1d, values_realwp_2d, values_realwp_3d  &
+            ) RESULT( return_value )
+
+   CHARACTER(LEN=charlen)            ::  file_format    !< file format chosen for file
+   CHARACTER(LEN=*),      INTENT(IN) ::  file_name      !< name of file
+   CHARACTER(LEN=*),      INTENT(IN) ::  variable_name  !< name of variable
+
+   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_write_var'  !< name of routine
+
+   INTEGER ::  file_id              !< file ID
+   INTEGER ::  i                    !< loop index
+   INTEGER ::  j                    !< loop index
+   INTEGER ::  k                    !< loop index
+   INTEGER ::  output_return_value  !< return value of a called output routine
+   INTEGER ::  return_value         !< return value
+   INTEGER ::  variable_id          !< variable ID
+
+   INTEGER, DIMENSION(:),   INTENT(IN)  ::  bounds_end             !< end index per dimension of variable
+   INTEGER, DIMENSION(:),   INTENT(IN)  ::  bounds_start           !< start index per dimension of variable
+   INTEGER, DIMENSION(:),   ALLOCATABLE ::  bounds_origin          !< first index of each dimension
+   INTEGER, DIMENSION(:),   ALLOCATABLE ::  bounds_start_internal  !< start index per dim. for output after masking
+   INTEGER, DIMENSION(:),   ALLOCATABLE ::  value_counts           !< count of indices to be written per dimension
+   INTEGER, DIMENSION(:,:), ALLOCATABLE ::  masked_indices         !< list containing all output indices along a dimension
+
+   LOGICAL ::  do_output  !< true if any data lies within given range of masked dimension
+   LOGICAL ::  is_global  !< true if variable is global
+
+   INTEGER(KIND=1), POINTER, INTENT(IN), OPTIONAL                   ::  values_int8_0d             !< output variable
+   INTEGER(KIND=2), POINTER, INTENT(IN), OPTIONAL                   ::  values_int16_0d            !< output variable
+   INTEGER(KIND=4), POINTER, INTENT(IN), OPTIONAL                   ::  values_int32_0d            !< output variable
+   INTEGER(iwp),    POINTER, INTENT(IN), OPTIONAL                   ::  values_intwp_0d            !< output variable
+   INTEGER(KIND=1), POINTER, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  values_int8_1d             !< output variable
+   INTEGER(KIND=2), POINTER, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  values_int16_1d            !< output variable
+   INTEGER(KIND=4), POINTER, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  values_int32_1d            !< output variable
+   INTEGER(iwp),    POINTER, INTENT(IN), OPTIONAL, DIMENSION(:)     ::  values_intwp_1d            !< output variable
+   INTEGER(KIND=1), POINTER, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  values_int8_2d             !< output variable
+   INTEGER(KIND=2), POINTER, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  values_int16_2d            !< output variable
+   INTEGER(KIND=4), POINTER, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  values_int32_2d            !< output variable
+   INTEGER(iwp),    POINTER, INTENT(IN), OPTIONAL, DIMENSION(:,:)   ::  values_intwp_2d            !< output variable
+   INTEGER(KIND=1), POINTER, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  values_int8_3d             !< output variable
+   INTEGER(KIND=2), POINTER, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  values_int16_3d            !< output variable
+   INTEGER(KIND=4), POINTER, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  values_int32_3d            !< output variable
+   INTEGER(iwp),    POINTER, INTENT(IN), OPTIONAL, DIMENSION(:,:,:) ::  values_intwp_3d            !< output variable
+
+   INTEGER(KIND=1), TARGET, ALLOCATABLE, DIMENSION(:)               ::  values_int8_1d_resorted    !< resorted output variable
+   INTEGER(KIND=2), TARGET, ALLOCATABLE, DIMENSION(:)               ::  values_int16_1d_resorted   !< resorted output variable
+   INTEGER(KIND=4), TARGET, ALLOCATABLE, DIMENSION(:)               ::  values_int32_1d_resorted   !< resorted output variable
+   INTEGER(iwp),    TARGET, ALLOCATABLE, DIMENSION(:)               ::  values_intwp_1d_resorted   !< resorted output variable
+   INTEGER(KIND=1), TARGET, ALLOCATABLE, DIMENSION(:,:)             ::  values_int8_2d_resorted    !< resorted output variable
+   INTEGER(KIND=2), TARGET, ALLOCATABLE, DIMENSION(:,:)             ::  values_int16_2d_resorted   !< resorted output variable
+   INTEGER(KIND=4), TARGET, ALLOCATABLE, DIMENSION(:,:)             ::  values_int32_2d_resorted   !< resorted output variable
+   INTEGER(iwp),    TARGET, ALLOCATABLE, DIMENSION(:,:)             ::  values_intwp_2d_resorted   !< resorted output variable
+   INTEGER(KIND=1), TARGET, ALLOCATABLE, DIMENSION(:,:,:)           ::  values_int8_3d_resorted    !< resorted output variable
+   INTEGER(KIND=2), TARGET, ALLOCATABLE, DIMENSION(:,:,:)           ::  values_int16_3d_resorted   !< resorted output variable
+   INTEGER(KIND=4), TARGET, ALLOCATABLE, DIMENSION(:,:,:)           ::  values_int32_3d_resorted   !< resorted output variable
+   INTEGER(iwp),    TARGET, ALLOCATABLE, DIMENSION(:,:,:)           ::  values_intwp_3d_resorted   !< resorted output variable
+
+   INTEGER(KIND=1), POINTER                                         ::  values_int8_0d_pointer     !< pointer to resortet array
+   INTEGER(KIND=2), POINTER                                         ::  values_int16_0d_pointer    !< pointer to resortet array
+   INTEGER(KIND=4), POINTER                                         ::  values_int32_0d_pointer    !< pointer to resortet array
+   INTEGER(iwp),    POINTER                                         ::  values_intwp_0d_pointer    !< pointer to resortet array
+   INTEGER(KIND=1), POINTER, CONTIGUOUS, DIMENSION(:)               ::  values_int8_1d_pointer     !< pointer to resortet array
+   INTEGER(KIND=2), POINTER, CONTIGUOUS, DIMENSION(:)               ::  values_int16_1d_pointer    !< pointer to resortet array
+   INTEGER(KIND=4), POINTER, CONTIGUOUS, DIMENSION(:)               ::  values_int32_1d_pointer    !< pointer to resortet array
+   INTEGER(iwp),    POINTER, CONTIGUOUS, DIMENSION(:)               ::  values_intwp_1d_pointer    !< pointer to resortet array
+   INTEGER(KIND=1), POINTER, CONTIGUOUS, DIMENSION(:,:)             ::  values_int8_2d_pointer     !< pointer to resortet array
+   INTEGER(KIND=2), POINTER, CONTIGUOUS, DIMENSION(:,:)             ::  values_int16_2d_pointer    !< pointer to resortet array
+   INTEGER(KIND=4), POINTER, CONTIGUOUS, DIMENSION(:,:)             ::  values_int32_2d_pointer    !< pointer to resortet array
+   INTEGER(iwp),    POINTER, CONTIGUOUS, DIMENSION(:,:)             ::  values_intwp_2d_pointer    !< pointer to resortet array
+   INTEGER(KIND=1), POINTER, CONTIGUOUS, DIMENSION(:,:,:)           ::  values_int8_3d_pointer     !< pointer to resortet array
+   INTEGER(KIND=2), POINTER, CONTIGUOUS, DIMENSION(:,:,:)           ::  values_int16_3d_pointer    !< pointer to resortet array
+   INTEGER(KIND=4), POINTER, CONTIGUOUS, DIMENSION(:,:,:)           ::  values_int32_3d_pointer    !< pointer to resortet array
+   INTEGER(iwp),    POINTER, CONTIGUOUS, DIMENSION(:,:,:)           ::  values_intwp_3d_pointer    !< pointer to resortet array
+
+   REAL(KIND=4), POINTER, INTENT(IN), OPTIONAL                      ::  values_real32_0d           !< output variable
+   REAL(KIND=8), POINTER, INTENT(IN), OPTIONAL                      ::  values_real64_0d           !< output variable
+   REAL(wp),     POINTER, INTENT(IN), OPTIONAL                      ::  values_realwp_0d           !< output variable
+   REAL(KIND=4), POINTER, INTENT(IN), OPTIONAL, DIMENSION(:)        ::  values_real32_1d           !< output variable
+   REAL(KIND=8), POINTER, INTENT(IN), OPTIONAL, DIMENSION(:)        ::  values_real64_1d           !< output variable
+   REAL(wp),     POINTER, INTENT(IN), OPTIONAL, DIMENSION(:)        ::  values_realwp_1d           !< output variable
+   REAL(KIND=4), POINTER, INTENT(IN), OPTIONAL, DIMENSION(:,:)      ::  values_real32_2d           !< output variable
+   REAL(KIND=8), POINTER, INTENT(IN), OPTIONAL, DIMENSION(:,:)      ::  values_real64_2d           !< output variable
+   REAL(wp),     POINTER, INTENT(IN), OPTIONAL, DIMENSION(:,:)      ::  values_realwp_2d           !< output variable
+   REAL(KIND=4), POINTER, INTENT(IN), OPTIONAL, DIMENSION(:,:,:)    ::  values_real32_3d           !< output variable
+   REAL(KIND=8), POINTER, INTENT(IN), OPTIONAL, DIMENSION(:,:,:)    ::  values_real64_3d           !< output variable
+   REAL(wp),     POINTER, INTENT(IN), OPTIONAL, DIMENSION(:,:,:)    ::  values_realwp_3d           !< output variable
+
+   REAL(KIND=4), TARGET, ALLOCATABLE, DIMENSION(:)                  ::  values_real32_1d_resorted  !< resorted output variable
+   REAL(KIND=8), TARGET, ALLOCATABLE, DIMENSION(:)                  ::  values_real64_1d_resorted  !< resorted output variable
+   REAL(wp),     TARGET, ALLOCATABLE, DIMENSION(:)                  ::  values_realwp_1d_resorted  !< resorted output variable
+   REAL(KIND=4), TARGET, ALLOCATABLE, DIMENSION(:,:)                ::  values_real32_2d_resorted  !< resorted output variable
+   REAL(KIND=8), TARGET, ALLOCATABLE, DIMENSION(:,:)                ::  values_real64_2d_resorted  !< resorted output variable
+   REAL(wp),     TARGET, ALLOCATABLE, DIMENSION(:,:)                ::  values_realwp_2d_resorted  !< resorted output variable
+   REAL(KIND=4), TARGET, ALLOCATABLE, DIMENSION(:,:,:)              ::  values_real32_3d_resorted  !< resorted output variable
+   REAL(KIND=8), TARGET, ALLOCATABLE, DIMENSION(:,:,:)              ::  values_real64_3d_resorted  !< resorted output variable
+   REAL(wp),     TARGET, ALLOCATABLE, DIMENSION(:,:,:)              ::  values_realwp_3d_resorted  !< resorted output variable
+
+   REAL(KIND=4), POINTER                                            ::  values_real32_0d_pointer   !< pointer to resortet array
+   REAL(KIND=8), POINTER                                            ::  values_real64_0d_pointer   !< pointer to resortet array
+   REAL(wp),     POINTER                                            ::  values_realwp_0d_pointer   !< pointer to resortet array
+   REAL(KIND=4), POINTER, CONTIGUOUS, DIMENSION(:)                  ::  values_real32_1d_pointer   !< pointer to resortet array
+   REAL(KIND=8), POINTER, CONTIGUOUS, DIMENSION(:)                  ::  values_real64_1d_pointer   !< pointer to resortet array
+   REAL(wp),     POINTER, CONTIGUOUS, DIMENSION(:)                  ::  values_realwp_1d_pointer   !< pointer to resortet array
+   REAL(KIND=4), POINTER, CONTIGUOUS, DIMENSION(:,:)                ::  values_real32_2d_pointer   !< pointer to resortet array
+   REAL(KIND=8), POINTER, CONTIGUOUS, DIMENSION(:,:)                ::  values_real64_2d_pointer   !< pointer to resortet array
+   REAL(wp),     POINTER, CONTIGUOUS, DIMENSION(:,:)                ::  values_realwp_2d_pointer   !< pointer to resortet array
+   REAL(KIND=4), POINTER, CONTIGUOUS, DIMENSION(:,:,:)              ::  values_real32_3d_pointer   !< pointer to resortet array
+   REAL(KIND=8), POINTER, CONTIGUOUS, DIMENSION(:,:,:)              ::  values_real64_3d_pointer   !< pointer to resortet array
+   REAL(wp),     POINTER, CONTIGUOUS, DIMENSION(:,:,:)              ::  values_realwp_3d_pointer   !< pointer to resortet array
+
+   TYPE(dimension_type), DIMENSION(:), ALLOCATABLE ::  dimension_list  !< list of used dimensions of variable
+
+
+   return_value = 0
+   output_return_value = 0
+
+   CALL internal_message( 'debug', routine_name // ': write ' // TRIM( variable_name ) // &
+                          ' into file ' // TRIM( file_name ) )
+
+   !-- Search for variable within file
+   CALL find_var_in_file( file_name, variable_name, file_format, file_id, variable_id, &
+                          is_global, dimension_list, return_value=return_value  )
+
+   IF ( return_value == 0 )  THEN
+
+      !-- Check if the correct amount of variable bounds were given
+      IF ( SIZE( bounds_start ) /= SIZE( dimension_list )  .OR.  &
+           SIZE( bounds_end ) /= SIZE( dimension_list ) )  THEN
+         return_value = 1
+         CALL internal_message( 'error', routine_name //                  &
+                                ': number bounds do not match with ' //   &
+                                'number of dimensions of variable ' //    &
+                                '(variable "' // TRIM( variable_name ) // &
+                                '", file "' // TRIM( file_name ) // '")!' )
+      ENDIF
+
+   ENDIF
+
+   IF ( return_value == 0 )  THEN
+
+      !-- Save starting index (lower bounds) of each dimension
+      ALLOCATE( bounds_origin(SIZE( dimension_list )) )
+      ALLOCATE( bounds_start_internal(SIZE( dimension_list )) )
+      ALLOCATE( value_counts(SIZE( dimension_list )) )
+
+      WRITE( temp_string, * ) bounds_start
+      CALL internal_message( 'debug', routine_name //                    &
+                             ': file "' // TRIM( file_name ) //          &
+                             '", variable "' // TRIM( variable_name ) // &
+                             '", bounds_start =' // TRIM( temp_string ) )
+      WRITE( temp_string, * ) bounds_end
+      CALL internal_message( 'debug', routine_name //                    &
+                             ': file "' // TRIM( file_name ) //          &
+                             '", variable "' // TRIM( variable_name ) // &
+                             '", bounds_end =' // TRIM( temp_string ) )
+
+      !-- Get bounds for masking
+      CALL get_masked_indices_and_masked_dimension_bounds( dimension_list,                  &
+              bounds_start, bounds_end, bounds_start_internal, value_counts, bounds_origin, &
+              masked_indices )
+
+      do_output = .NOT. ANY( value_counts == 0 )
+
+      WRITE( temp_string, * ) bounds_start_internal
+      CALL internal_message( 'debug', routine_name //                    &
+                             ': file "' // TRIM( file_name ) //          &
+                             '", variable "' // TRIM( variable_name ) // &
+                             '", bounds_start_internal =' // TRIM( temp_string ) )
+      WRITE( temp_string, * ) value_counts
+      CALL internal_message( 'debug', routine_name //                    &
+                             ': file "' // TRIM( file_name ) //          &
+                             '", variable "' // TRIM( variable_name ) // &
+                             '", value_counts =' // TRIM( temp_string ) )
+
+      !-- Mask and resort variable
+      !-- 8bit integer output
+      IF ( PRESENT( values_int8_0d ) )  THEN
+         values_int8_0d_pointer => values_int8_0d
+      ELSEIF ( PRESENT( values_int8_1d ) )  THEN
+         IF ( do_output ) THEN
+            ALLOCATE( values_int8_1d_resorted(0:value_counts(1)-1) )
+            !$OMP PARALLEL PRIVATE (i)
+            !$OMP DO
+            DO  i = 0, value_counts(1) - 1
+               values_int8_1d_resorted(i) = values_int8_1d(masked_indices(1,i))
+            ENDDO
+            !$OMP END PARALLEL
+         ELSE
+            ALLOCATE( values_int8_1d_resorted(1) )
+            values_int8_1d_resorted = 0_1
+         ENDIF
+         values_int8_1d_pointer => values_int8_1d_resorted
+      ELSEIF ( PRESENT( values_int8_2d ) )  THEN
+         IF ( do_output ) THEN
+            ALLOCATE( values_int8_2d_resorted(0:value_counts(1)-1, &
+                                              0:value_counts(2)-1) )
+            !$OMP PARALLEL PRIVATE (i,j)
+            !$OMP DO
+            DO  i = 0, value_counts(1) - 1
+               DO  j = 0, value_counts(2) - 1
+                  values_int8_2d_resorted(i,j) = values_int8_2d(masked_indices(2,j), &
+                                                                masked_indices(1,i)  )
+               ENDDO
+            ENDDO
+            !$OMP END PARALLEL
+         ELSE
+            ALLOCATE( values_int8_2d_resorted(1,1) )
+            values_int8_2d_resorted = 0_1
+         ENDIF
+         values_int8_2d_pointer => values_int8_2d_resorted
+      ELSEIF ( PRESENT( values_int8_3d ) )  THEN
+         IF ( do_output ) THEN
+            ALLOCATE( values_int8_3d_resorted(0:value_counts(1)-1, &
+                                              0:value_counts(2)-1, &
+                                              0:value_counts(3)-1) )
+            !$OMP PARALLEL PRIVATE (i,j,k)
+            !$OMP DO
+            DO  i = 0, value_counts(1) - 1
+               DO  j = 0, value_counts(2) - 1
+                  DO  k = 0, value_counts(3) - 1
+                     values_int8_3d_resorted(i,j,k) = values_int8_3d(masked_indices(3,k), &
+                                                                     masked_indices(2,j), &
+                                                                     masked_indices(1,i)  )
+                  ENDDO
+               ENDDO
+            ENDDO
+            !$OMP END PARALLEL
+         ELSE
+            ALLOCATE( values_int8_3d_resorted(1,1,1) )
+            values_int8_3d_resorted = 0_1
+         ENDIF
+         values_int8_3d_pointer => values_int8_3d_resorted
+
+      !-- 16bit integer output
+      ELSEIF ( PRESENT( values_int16_0d ) )  THEN
+         values_int16_0d_pointer => values_int16_0d
+      ELSEIF ( PRESENT( values_int16_1d ) )  THEN
+         IF ( do_output ) THEN
+            ALLOCATE( values_int16_1d_resorted(0:value_counts(1)-1) )
+            !$OMP PARALLEL PRIVATE (i)
+            !$OMP DO
+            DO  i = 0, value_counts(1) - 1
+               values_int16_1d_resorted(i) = values_int16_1d(masked_indices(1,i))
+            ENDDO
+            !$OMP END PARALLEL
+         ELSE
+            ALLOCATE( values_int16_1d_resorted(1) )
+            values_int16_1d_resorted = 0_1
+         ENDIF
+         values_int16_1d_pointer => values_int16_1d_resorted
+      ELSEIF ( PRESENT( values_int16_2d ) )  THEN
+         IF ( do_output ) THEN
+            ALLOCATE( values_int16_2d_resorted(0:value_counts(1)-1, &
+                                               0:value_counts(2)-1) )
+            !$OMP PARALLEL PRIVATE (i,j)
+            !$OMP DO
+            DO  i = 0, value_counts(1) - 1
+               DO  j = 0, value_counts(2) - 1
+                  values_int16_2d_resorted(i,j) = values_int16_2d(masked_indices(2,j), &
+                                                                  masked_indices(1,i))
+               ENDDO
+            ENDDO
+            !$OMP END PARALLEL
+         ELSE
+            ALLOCATE( values_int16_2d_resorted(1,1) )
+            values_int16_2d_resorted = 0_1
+         ENDIF
+         values_int16_2d_pointer => values_int16_2d_resorted
+      ELSEIF ( PRESENT( values_int16_3d ) )  THEN
+         IF ( do_output ) THEN
+            ALLOCATE( values_int16_3d_resorted(0:value_counts(1)-1, &
+                                               0:value_counts(2)-1, &
+                                               0:value_counts(3)-1) )
+            !$OMP PARALLEL PRIVATE (i,j,k)
+            !$OMP DO
+            DO  i = 0, value_counts(1) - 1
+               DO  j = 0, value_counts(2) - 1
+                  DO  k = 0, value_counts(3) - 1
+                     values_int16_3d_resorted(i,j,k) = values_int16_3d(masked_indices(3,k), &
+                                                                       masked_indices(2,j), &
+                                                                       masked_indices(1,i)  )
+                  ENDDO
+               ENDDO
+            ENDDO
+            !$OMP END PARALLEL
+         ELSE
+            ALLOCATE( values_int16_3d_resorted(1,1,1) )
+            values_int16_3d_resorted = 0_1
+         ENDIF
+         values_int16_3d_pointer => values_int16_3d_resorted
+
+      !-- 32bit integer output
+      ELSEIF ( PRESENT( values_int32_0d ) )  THEN
+         values_int32_0d_pointer => values_int32_0d
+      ELSEIF ( PRESENT( values_int32_1d ) )  THEN
+         IF ( do_output ) THEN
+            ALLOCATE( values_int32_1d_resorted(0:value_counts(1)-1) )
+            !$OMP PARALLEL PRIVATE (i)
+            !$OMP DO
+            DO  i = 0, value_counts(1) - 1
+               values_int32_1d_resorted(i) = values_int32_1d(masked_indices(1,i))
+            ENDDO
+            !$OMP END PARALLEL
+         ELSE
+            ALLOCATE( values_int32_1d_resorted(1) )
+            values_int32_1d_resorted = 0_1
+         ENDIF
+         values_int32_1d_pointer => values_int32_1d_resorted
+      ELSEIF ( PRESENT( values_int32_2d ) )  THEN
+         IF ( do_output ) THEN
+            ALLOCATE( values_int32_2d_resorted(0:value_counts(1)-1, &
+                                               0:value_counts(2)-1) )
+            !$OMP PARALLEL PRIVATE (i,j)
+            !$OMP DO
+            DO  i = 0, value_counts(1) - 1
+               DO  j = 0, value_counts(2) - 1
+                  values_int32_2d_resorted(i,j) = values_int32_2d(masked_indices(2,j), &
+                                                                  masked_indices(1,i)  )
+               ENDDO
+            ENDDO
+            !$OMP END PARALLEL
+         ELSE
+            ALLOCATE( values_int32_2d_resorted(1,1) )
+            values_int32_2d_resorted = 0_1
+         ENDIF
+         values_int32_2d_pointer => values_int32_2d_resorted
+      ELSEIF ( PRESENT( values_int32_3d ) )  THEN
+         IF ( do_output ) THEN
+            ALLOCATE( values_int32_3d_resorted(0:value_counts(1)-1, &
+                                               0:value_counts(2)-1, &
+                                               0:value_counts(3)-1) )
+            !$OMP PARALLEL PRIVATE (i,j,k)
+            !$OMP DO
+            DO  i = 0, value_counts(1) - 1
+               DO  j = 0, value_counts(2) - 1
+                  DO  k = 0, value_counts(3) - 1
+                     values_int32_3d_resorted(i,j,k) = values_int32_3d(masked_indices(3,k), &
+                                                                       masked_indices(2,j), &
+                                                                       masked_indices(1,i)  )
+                  ENDDO
+               ENDDO
+            ENDDO
+            !$OMP END PARALLEL
+         ELSE
+            ALLOCATE( values_int32_3d_resorted(1,1,1) )
+            values_int32_3d_resorted = 0_1
+         ENDIF
+         values_int32_3d_pointer => values_int32_3d_resorted
+
+      !-- working-precision integer output
+      ELSEIF ( PRESENT( values_intwp_0d ) )  THEN
+         values_intwp_0d_pointer => values_intwp_0d
+      ELSEIF ( PRESENT( values_intwp_1d ) )  THEN
+         IF ( do_output ) THEN
+            ALLOCATE( values_intwp_1d_resorted(0:value_counts(1)-1) )
+            !$OMP PARALLEL PRIVATE (i)
+            !$OMP DO
+            DO  i = 0, value_counts(1) - 1
+               values_intwp_1d_resorted(i) = values_intwp_1d(masked_indices(1,i))
+            ENDDO
+            !$OMP END PARALLEL
+         ELSE
+            ALLOCATE( values_intwp_1d_resorted(1) )
+            values_intwp_1d_resorted = 0_1
+         ENDIF
+         values_intwp_1d_pointer => values_intwp_1d_resorted
+      ELSEIF ( PRESENT( values_intwp_2d ) )  THEN
+         IF ( do_output ) THEN
+            ALLOCATE( values_intwp_2d_resorted(0:value_counts(1)-1, &
+                                               0:value_counts(2)-1) )
+            !$OMP PARALLEL PRIVATE (i,j)
+            !$OMP DO
+            DO  i = 0, value_counts(1) - 1
+               DO  j = 0, value_counts(2) - 1
+                  values_intwp_2d_resorted(i,j) = values_intwp_2d(masked_indices(2,j), &
+                                                                  masked_indices(1,i)  )
+               ENDDO
+            ENDDO
+            !$OMP END PARALLEL
+         ELSE
+            ALLOCATE( values_intwp_2d_resorted(1,1) )
+            values_intwp_2d_resorted = 0_1
+         ENDIF
+         values_intwp_2d_pointer => values_intwp_2d_resorted
+      ELSEIF ( PRESENT( values_intwp_3d ) )  THEN
+         IF ( do_output ) THEN
+            ALLOCATE( values_intwp_3d_resorted(0:value_counts(1)-1, &
+                                               0:value_counts(2)-1, &
+                                               0:value_counts(3)-1) )
+            !$OMP PARALLEL PRIVATE (i,j,k)
+            !$OMP DO
+            DO  i = 0, value_counts(1) - 1
+               DO  j = 0, value_counts(2) - 1
+                  DO  k = 0, value_counts(3) - 1
+                     values_intwp_3d_resorted(i,j,k) = values_intwp_3d(masked_indices(3,k), &
+                                                                       masked_indices(2,j), &
+                                                                       masked_indices(1,i)  )
+                  ENDDO
+               ENDDO
+            ENDDO
+            !$OMP END PARALLEL
+         ELSE
+            ALLOCATE( values_intwp_3d_resorted(1,1,1) )
+            values_intwp_3d_resorted = 0_1
+         ENDIF
+         values_intwp_3d_pointer => values_intwp_3d_resorted
+
+      !-- 32bit real output
+      ELSEIF ( PRESENT( values_real32_0d ) )  THEN
+         values_real32_0d_pointer => values_real32_0d
+      ELSEIF ( PRESENT( values_real32_1d ) )  THEN
+         IF ( do_output ) THEN
+            ALLOCATE( values_real32_1d_resorted(0:value_counts(1)-1) )
+            !$OMP PARALLEL PRIVATE (i)
+            !$OMP DO
+            DO  i = 0, value_counts(1) - 1
+               values_real32_1d_resorted(i) = values_real32_1d(masked_indices(1,i))
+            ENDDO
+            !$OMP END PARALLEL
+         ELSE
+            ALLOCATE( values_real32_1d_resorted(1) )
+            values_real32_1d_resorted = 0_1
+         ENDIF
+         values_real32_1d_pointer => values_real32_1d_resorted
+      ELSEIF ( PRESENT( values_real32_2d ) )  THEN
+         IF ( do_output ) THEN
+            ALLOCATE( values_real32_2d_resorted(0:value_counts(1)-1, &
+                                                0:value_counts(2)-1) )
+            !$OMP PARALLEL PRIVATE (i,j)
+            !$OMP DO
+            DO  i = 0, value_counts(1) - 1
+               DO  j = 0, value_counts(2) - 1
+                  values_real32_2d_resorted(i,j) = values_real32_2d(masked_indices(2,j), &
+                                                                    masked_indices(1,i)  )
+               ENDDO
+            ENDDO
+            !$OMP END PARALLEL
+         ELSE
+            ALLOCATE( values_real32_2d_resorted(1,1) )
+            values_real32_2d_resorted = 0_1
+         ENDIF
+         values_real32_2d_pointer => values_real32_2d_resorted
+      ELSEIF ( PRESENT( values_real32_3d ) )  THEN
+         IF ( do_output ) THEN
+            ALLOCATE( values_real32_3d_resorted(0:value_counts(1)-1, &
+                                                0:value_counts(2)-1, &
+                                                0:value_counts(3)-1) )
+            !$OMP PARALLEL PRIVATE (i,j,k)
+            !$OMP DO
+            DO  i = 0, value_counts(1) - 1
+               DO  j = 0, value_counts(2) - 1
+                  DO  k = 0, value_counts(3) - 1
+                     values_real32_3d_resorted(i,j,k) = values_real32_3d(masked_indices(3,k), &
+                                                                         masked_indices(2,j), &
+                                                                         masked_indices(1,i)  )
+                  ENDDO
+               ENDDO
+            ENDDO
+            !$OMP END PARALLEL
+         ELSE
+            ALLOCATE( values_real32_3d_resorted(1,1,1) )
+            values_real32_3d_resorted = 0_1
+         ENDIF
+         values_real32_3d_pointer => values_real32_3d_resorted
+
+      !-- 64bit real output
+      ELSEIF ( PRESENT( values_real64_0d ) )  THEN
+         values_real64_0d_pointer => values_real64_0d
+      ELSEIF ( PRESENT( values_real64_1d ) )  THEN
+         IF ( do_output ) THEN
+            ALLOCATE( values_real64_1d_resorted(0:value_counts(1)-1) )
+            !$OMP PARALLEL PRIVATE (i)
+            !$OMP DO
+            DO  i = 0, value_counts(1) - 1
+               values_real64_1d_resorted(i) = values_real64_1d(masked_indices(1,i))
+            ENDDO
+            !$OMP END PARALLEL
+         ELSE
+            ALLOCATE( values_real64_1d_resorted(1) )
+            values_real64_1d_resorted = 0_1
+         ENDIF
+         values_real64_1d_pointer => values_real64_1d_resorted
+      ELSEIF ( PRESENT( values_real64_2d ) )  THEN
+         IF ( do_output ) THEN
+            ALLOCATE( values_real64_2d_resorted(0:value_counts(1)-1, &
+                                                0:value_counts(2)-1) )
+            !$OMP PARALLEL PRIVATE (i,j)
+            !$OMP DO
+            DO  i = 0, value_counts(1) - 1
+               DO  j = 0, value_counts(2) - 1
+                  values_real64_2d_resorted(i,j) = values_real64_2d(masked_indices(2,j), &
+                                                                    masked_indices(1,i)  )
+               ENDDO
+            ENDDO
+            !$OMP END PARALLEL
+         ELSE
+            ALLOCATE( values_real64_2d_resorted(1,1) )
+            values_real64_2d_resorted = 0_1
+         ENDIF
+         values_real64_2d_pointer => values_real64_2d_resorted
+      ELSEIF ( PRESENT( values_real64_3d ) )  THEN
+         IF ( do_output ) THEN
+            ALLOCATE( values_real64_3d_resorted(0:value_counts(1)-1, &
+                                                0:value_counts(2)-1, &
+                                                0:value_counts(3)-1) )
+            !$OMP PARALLEL PRIVATE (i,j,k)
+            !$OMP DO
+            DO  i = 0, value_counts(1) - 1
+               DO  j = 0, value_counts(2) - 1
+                  DO  k = 0, value_counts(3) - 1
+                     values_real64_3d_resorted(i,j,k) = values_real64_3d(masked_indices(3,k), &
+                                                                         masked_indices(2,j), &
+                                                                         masked_indices(1,i)  )
+                  ENDDO
+               ENDDO
+            ENDDO
+            !$OMP END PARALLEL
+         ELSE
+            ALLOCATE( values_real64_3d_resorted(1,1,1) )
+            values_real64_3d_resorted = 0_1
+         ENDIF
+         values_real64_3d_pointer => values_real64_3d_resorted
+
+      !-- working-precision real output
+      ELSEIF ( PRESENT( values_realwp_0d ) )  THEN
+         values_realwp_0d_pointer => values_realwp_0d
+      ELSEIF ( PRESENT( values_realwp_1d ) )  THEN
+         IF ( do_output ) THEN
+            ALLOCATE( values_realwp_1d_resorted(0:value_counts(1)-1) )
+            !$OMP PARALLEL PRIVATE (i)
+            !$OMP DO
+            DO  i = 0, value_counts(1) - 1
+               values_realwp_1d_resorted(i) = values_realwp_1d(masked_indices(1,i))
+            ENDDO
+            !$OMP END PARALLEL
+         ELSE
+            ALLOCATE( values_realwp_1d_resorted(1) )
+            values_realwp_1d_resorted = 0_1
+         ENDIF
+         values_realwp_1d_pointer => values_realwp_1d_resorted
+      ELSEIF ( PRESENT( values_realwp_2d ) )  THEN
+         IF ( do_output ) THEN
+            ALLOCATE( values_realwp_2d_resorted(0:value_counts(1)-1, &
+                                                0:value_counts(2)-1) )
+            !$OMP PARALLEL PRIVATE (i,j)
+            !$OMP DO
+            DO  i = 0, value_counts(1) - 1
+               DO  j = 0, value_counts(2) - 1
+                  values_realwp_2d_resorted(i,j) = values_realwp_2d(masked_indices(2,j), &
+                                                                    masked_indices(1,i)  )
+               ENDDO
+            ENDDO
+            !$OMP END PARALLEL
+         ELSE
+            ALLOCATE( values_realwp_2d_resorted(1,1) )
+            values_realwp_2d_resorted = 0_1
+         ENDIF
+         values_realwp_2d_pointer => values_realwp_2d_resorted
+      ELSEIF ( PRESENT( values_realwp_3d ) )  THEN
+         IF ( do_output ) THEN
+            ALLOCATE( values_realwp_3d_resorted(0:value_counts(1)-1, &
+                                                0:value_counts(2)-1, &
+                                                0:value_counts(3)-1) )
+            !$OMP PARALLEL PRIVATE (i,j,k)
+            !$OMP DO
+            DO  i = 0, value_counts(1) - 1
+               DO  j = 0, value_counts(2) - 1
+                  DO  k = 0, value_counts(3) - 1
+                     values_realwp_3d_resorted(i,j,k) = values_realwp_3d(masked_indices(3,k), &
+                                                                         masked_indices(2,j), &
+                                                                         masked_indices(1,i)  )
+                  ENDDO
+               ENDDO
+            ENDDO
+            !$OMP END PARALLEL
+         ELSE
+            ALLOCATE( values_realwp_3d_resorted(1,1,1) )
+            values_realwp_3d_resorted = 0_1
+         ENDIF
+         values_realwp_3d_pointer => values_realwp_3d_resorted
+
       ELSE
-         return_value = dom_def_att_save( TRIM( filename ), &
-                                                attribute=attribute, append=append_internal )
+         return_value = 1
+         CALL internal_message( 'error', routine_name //                  &
+                                ': no output values given ' //            &
+                                '(variable "' // TRIM( variable_name ) // &
+                                '", file "' // TRIM( file_name ) // '")!'  )
       ENDIF
+
+      DEALLOCATE( masked_indices )
+
+   ENDIF  ! Check for error
+
+   IF ( return_value == 0 )  THEN
+
+      !-- Write variable into file
+      SELECT CASE ( TRIM( file_format ) )
+
+         CASE ( 'binary' )
+            !-- 8bit integer output
+            IF ( PRESENT( values_int8_0d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_int8_0d=values_int8_0d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_int8_1d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_int8_1d=values_int8_1d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_int8_2d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_int8_2d=values_int8_2d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_int8_3d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_int8_3d=values_int8_3d_pointer, return_value=output_return_value )
+            !-- 16bit integer output
+            ELSEIF ( PRESENT( values_int16_0d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_int16_0d=values_int16_0d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_int16_1d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_int16_1d=values_int16_1d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_int16_2d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_int16_2d=values_int16_2d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_int16_3d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_int16_3d=values_int16_3d_pointer, return_value=output_return_value )
+            !-- 32bit integer output
+            ELSEIF ( PRESENT( values_int32_0d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_int32_0d=values_int32_0d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_int32_1d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_int32_1d=values_int32_1d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_int32_2d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_int32_2d=values_int32_2d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_int32_3d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_int32_3d=values_int32_3d_pointer, return_value=output_return_value )
+            !-- working-precision integer output
+            ELSEIF ( PRESENT( values_intwp_0d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_intwp_0d=values_intwp_0d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_intwp_1d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_intwp_1d=values_intwp_1d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_intwp_2d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_intwp_2d=values_intwp_2d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_intwp_3d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_intwp_3d=values_intwp_3d_pointer, return_value=output_return_value )
+            !-- 32bit real output
+            ELSEIF ( PRESENT( values_real32_0d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_real32_0d=values_real32_0d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_real32_1d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_real32_1d=values_real32_1d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_real32_2d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_real32_2d=values_real32_2d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_real32_3d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_real32_3d=values_real32_3d_pointer, return_value=output_return_value )
+            !-- 64bit real output
+            ELSEIF ( PRESENT( values_real64_0d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_real64_0d=values_real64_0d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_real64_1d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_real64_1d=values_real64_1d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_real64_2d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_real64_2d=values_real64_2d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_real64_3d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_real64_3d=values_real64_3d_pointer, return_value=output_return_value )
+            !-- working-precision real output
+            ELSEIF ( PRESENT( values_realwp_0d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_realwp_0d=values_realwp_0d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_realwp_1d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_realwp_1d=values_realwp_1d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_realwp_2d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_realwp_2d=values_realwp_2d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_realwp_3d ) )  THEN
+               CALL binary_write_variable( file_id, variable_id,                      &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_realwp_3d=values_realwp_3d_pointer, return_value=output_return_value )
+            ELSE
+               return_value = 1
+               CALL internal_message( 'error', routine_name //                          &
+                                      ': output_type not supported by file format "' // &
+                                      TRIM( file_format ) // '" ' //                    &
+                                      '(variable "' // TRIM( variable_name ) //         &
+                                      '", file "' // TRIM( file_name ) // '")!' )
+            ENDIF
+
+         CASE ( 'netcdf4-parallel', 'netcdf4-serial' )
+            !-- 8bit integer output
+            IF ( PRESENT( values_int8_0d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_int8_0d=values_int8_0d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_int8_1d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_int8_1d=values_int8_1d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_int8_2d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_int8_2d=values_int8_2d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_int8_3d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_int8_3d=values_int8_3d_pointer, return_value=output_return_value )
+            !-- 16bit integer output
+            ELSEIF ( PRESENT( values_int16_0d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_int16_0d=values_int16_0d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_int16_1d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_int16_1d=values_int16_1d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_int16_2d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_int16_2d=values_int16_2d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_int16_3d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_int16_3d=values_int16_3d_pointer, return_value=output_return_value )
+            !-- 32bit integer output
+            ELSEIF ( PRESENT( values_int32_0d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_int32_0d=values_int32_0d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_int32_1d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_int32_1d=values_int32_1d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_int32_2d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_int32_2d=values_int32_2d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_int32_3d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_int32_3d=values_int32_3d_pointer, return_value=output_return_value )
+            !-- working-precision integer output
+            ELSEIF ( PRESENT( values_intwp_0d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_intwp_0d=values_intwp_0d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_intwp_1d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_intwp_1d=values_intwp_1d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_intwp_2d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_intwp_2d=values_intwp_2d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_intwp_3d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_intwp_3d=values_intwp_3d_pointer, return_value=output_return_value )
+            !-- 32bit real output
+            ELSEIF ( PRESENT( values_real32_0d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_real32_0d=values_real32_0d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_real32_1d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_real32_1d=values_real32_1d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_real32_2d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_real32_2d=values_real32_2d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_real32_3d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_real32_3d=values_real32_3d_pointer, return_value=output_return_value )
+            !-- 64bit real output
+            ELSEIF ( PRESENT( values_real64_0d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_real64_0d=values_real64_0d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_real64_1d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_real64_1d=values_real64_1d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_real64_2d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_real64_2d=values_real64_2d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_real64_3d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_real64_3d=values_real64_3d_pointer, return_value=output_return_value )
+            !-- working-precision real output
+            ELSEIF ( PRESENT( values_realwp_0d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_realwp_0d=values_realwp_0d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_realwp_1d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_realwp_1d=values_realwp_1d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_realwp_2d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_realwp_2d=values_realwp_2d_pointer, return_value=output_return_value )
+            ELSEIF ( PRESENT( values_realwp_3d ) )  THEN
+               CALL netcdf4_write_variable( file_id, variable_id,                     &
+                       bounds_start_internal, value_counts, bounds_origin, is_global, &
+                       values_realwp_3d=values_realwp_3d_pointer, return_value=output_return_value )
+            ELSE
+               return_value = 1
+               CALL internal_message( 'error', routine_name //                          &
+                                      ': output_type not supported by file format "' // &
+                                      TRIM( file_format ) // '" ' //                    &
+                                      '(variable "' // TRIM( variable_name ) //         &
+                                      '", file "' // TRIM( file_name ) // '")!' )
+            ENDIF
+
+         CASE DEFAULT
+            return_value = 1
+            CALL internal_message( 'error', routine_name //                    &
+                                   ': file format "' // TRIM( file_format ) // &
+                                   '" not supported ' //                       &
+                                   '(variable "' // TRIM( variable_name ) //   &
+                                   '", file "' // TRIM( file_name ) // '")!' )
+
+      END SELECT
+
+      IF ( return_value == 0  .AND.  output_return_value /= 0 )  THEN
+         return_value = 1
+         CALL internal_message( 'error', routine_name //                  &
+                                ': error while writing variable ' //      &
+                                '(variable "' // TRIM( variable_name ) // &
+                                '", file "' // TRIM( file_name ) // '")!' )
+      ENDIF
+
    ENDIF
 
-END FUNCTION dom_def_att_real64
+END FUNCTION dom_write_var
+
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Finalize output.
+!> All necessary steps are carried out to close all output files. If a file could not be closed,
+!> this is noted in the error message.
+!>
+!> @bug if multiple files failed to be closed, only the last failure is given in the error message.
+!--------------------------------------------------------------------------------------------------!
+FUNCTION dom_finalize_output() RESULT( return_value )
+
+   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_finalize_output'  !< name of routine
+
+   INTEGER ::  f                      !< loop index
+   INTEGER ::  output_return_value    !< return value from called routines
+   INTEGER ::  return_value           !< return value
+   INTEGER ::  return_value_internal  !< error code after closing a single file
+
+
+   return_value = 0
+
+   DO  f = 1, nfiles
+
+      IF ( files(f)%is_init )  THEN
+
+         output_return_value = 0
+         return_value_internal = 0
+
+         SELECT CASE ( TRIM( files(f)%format ) )
+
+            CASE ( 'binary' )
+               CALL binary_finalize( files(f)%id, output_return_value )
+
+            CASE ( 'netcdf4-parallel', 'netcdf4-serial' )
+               CALL netcdf4_finalize( files(f)%id, output_return_value )
+
+            CASE DEFAULT
+               return_value_internal = 1
+
+         END SELECT
+
+         IF ( output_return_value /= 0 )  THEN
+            return_value = output_return_value
+            CALL internal_message( 'error', routine_name //             &
+                                   ': error while finalizing file "' // &
+                                   TRIM( files(f)%name ) // '"' )
+         ELSEIF ( return_value_internal /= 0 )  THEN
+            return_value = return_value_internal
+            CALL internal_message( 'error', routine_name //                     &
+                                   ': unsupported file format "' //             &
+                                   TRIM( files(f)%format ) // '" for file "' // &
+                                   TRIM( files(f)%name ) // '"' )
+         ENDIF
+
+      ENDIF
+
+   ENDDO
+
+END FUNCTION dom_finalize_output
+
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Return the last created error message.
+!--------------------------------------------------------------------------------------------------!
+FUNCTION dom_get_error_message() RESULT( error_message )
+
+   CHARACTER(LEN=800) ::  error_message  !< return error message to main program
+
+
+   error_message = TRIM( internal_error_message )
+
+   error_message = TRIM( error_message ) // TRIM( binary_get_error_message() )
+   
+   error_message = TRIM( error_message ) // TRIM( netcdf4_get_error_message() )
+   
+   internal_error_message = ''
+
+END FUNCTION dom_get_error_message
 
 !--------------------------------------------------------------------------------------------------!
